indexing

	description:

		"Universal error handlers for parsing arguments"

	library: "Gobo Eiffel Argument Library"
	copyright: "Copyright (c) 2006, Bernd Schoeller and others"
	license: "MIT License"
	date: "$Date: 2007-01-26 10:55:25 -0800 (Fri, 26 Jan 2007) $"
	revision: "$Revision: 5877 $"

class AP_ERROR_HANDLER

inherit

	UT_ERROR_HANDLER
		redefine
			report_error_message
		end

create

	make_standard,
	make_null

feature -- Error detection

	has_error: BOOLEAN
			-- Has an error been detected?

	reset is
			-- Reset `has_errors' to false.
		do
			has_error := False
		ensure
			reset: not has_error
		end

feature -- Error reporting

	report_error_message (an_error: STRING) is
			-- Report `an_error'.
		do
			has_error := True
			Precursor (an_error)
		end

end
