indexing

	description:

		"Eiffel deferred routines"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 1999-2002, Eric Bezault and others"
	license: "MIT License"
	date: "$Date: 2007-01-26 10:55:25 -0800 (Fri, 26 Jan 2007) $"
	revision: "$Revision: 5877 $"

deferred class ET_DEFERRED_ROUTINE

inherit

	ET_ROUTINE
		redefine
			is_deferred
		end

feature -- Status report

	is_deferred: BOOLEAN is True
			-- Is feature deferred?

feature -- Access

	deferred_keyword: ET_KEYWORD
			-- 'deferred' keyword

feature -- Setting

	set_deferred_keyword (a_deferred: like deferred_keyword) is
			-- Set `deferred_keyword' to `a_deferred'.
		require
			a_deferred_not_void: a_deferred /= Void
		do
			deferred_keyword := a_deferred
		ensure
			deferred_keyword_set: deferred_keyword = a_deferred
		end

invariant

	deferred_keyword_not_void: deferred_keyword /= Void

end
