indexing

	description:

		"Eiffel labeled actual generic parameters whose label is followed by a comma"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 2006, Eric Bezault and others"
	license: "MIT License"
	date: "$Date: 2007-07-08 20:53:21 -0700 (Sun, 08 Jul 2007) $"
	revision: "$Revision: 6003 $"

class ET_LABELED_COMMA_ACTUAL_PARAMETER

inherit

	ET_LABELED_ACTUAL_PARAMETER
		redefine
			is_last_entity,
			break, last_leaf, process
		end

create

	make

feature -- Status report

	is_last_entity: BOOLEAN is
			-- Is current entity the last entity in an
			-- entity declaration group?
		do
			Result := False
		end

feature -- Access

	last_leaf: ET_AST_LEAF is
			-- Last leaf node in current node
		do
			Result := label_item.last_leaf
		end

	break: ET_BREAK is
			-- Break which appears just after current node
		do
			Result := label_item.break
		end

feature -- Processing

	process (a_processor: ET_AST_PROCESSOR) is
			-- Process current node.
		do
			a_processor.process_labeled_comma_actual_parameter (Current)
		end

end
