indexing

	description:

		"Eiffel classic consumers of .NET assemblies"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 2006, Eric Bezault and others"
	license: "MIT License"
	date: "$Date: 2007-01-26 10:55:25 -0800 (Fri, 26 Jan 2007) $"
	revision: "$Revision: 5877 $"

class ET_DOTNET_ASSEMBLY_CLASSIC_CONSUMER

inherit

	ET_DOTNET_ASSEMBLY_CONSUMER

create

	make

feature -- Consuming

	consume_class (a_class: ET_CLASS) is
			-- Consume `a_class'.
		do
			a_class.set_parsed
			a_class.set_syntax_error
			error_handler.report_gaaaa_error (a_class.group.dotnet_assembly)
		end

feature {ET_DOTNET_ASSEMBLY} -- Consuming

	consume_assembly (an_assembly: ET_DOTNET_ASSEMBLY) is
			-- Eiffel classic compilers are not able to consume .NET assemblies.
		do
			error_handler.report_gaaaa_error (an_assembly)
		end

	consume_gac_assembly (an_assembly: ET_DOTNET_GAC_ASSEMBLY) is
			-- Eiffel classic compilers are not able to consume .NET assemblies.
		do
			error_handler.report_gaaaa_error (an_assembly)
		end

end
