indexing

	description:

		"Factories for Expat XML parsers"

	library: "Gobo Eiffel XML Library"
	copyright: "Copyright (c) 2001, Eric Bezault and others"
	license: "MIT License"
	date: "$Date: 2007-01-26 10:55:25 -0800 (Fri, 26 Jan 2007) $"
	revision: "$Revision: 5877 $"

class XM_EXPAT_PARSER_FACTORY

inherit

	XM_PARSER_FACTORY
		rename
			is_parser_available as is_expat_parser_available,
			new_parser as new_expat_parser
		end

feature -- Status report

	is_expat_parser_available: BOOLEAN is
			-- Is Expat XML parser available?
		do
			Result := False
		end

	is_expat_available: BOOLEAN is
			-- Is Expat XML parser available?
		obsolete
			"[020812] Use `is_expat_parser_available' instead."
		do
			Result := is_expat_parser_available
		end

feature -- Access

	new_expat_parser: XM_PARSER is
			-- New Expat XML parser
		do
		ensure then
			not_possible: False
		end

end
