indexing

	description:

		"Shared singleton4"

	library: "Gobo Eiffel Pattern Library"
	copyright: "Copyright (c) 2003, Eric Bezault and others"
	license: "MIT License"
	date: "$Date: 2007-01-26 10:55:25 -0800 (Fri, 26 Jan 2007) $"
	revision: "$Revision: 5877 $"

class SHARED_SINGLETON4

feature -- Access

	singleton4: SINGLETON4 is
			-- Singleton object
		do
			Result := singleton4_cell.item
			if Result = Void then
				create Result.make
			end
		ensure
			singleton4_created: singleton4_created
			singleton4_not_void: Result /= Void
		end

feature -- Status report

	singleton4_created: BOOLEAN is
			-- Has singleton already been created?
		do
			Result := singleton4_cell.item /= Void
		end

feature {NONE} -- Implementation

	singleton4_cell: DS_CELL [SINGLETON4] is
			-- Cell containing the singleton if already created
		once
			create Result.make (Void)
		ensure
			cell_not_void: Result /= Void
		end

end
